/*
	LUSScreenSaver Plugin Interface
	Copyright (C) 2003 ONO,Masayuki.<mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "LUSSSPicture.h"
#include "LUSSSPictureSetting.h"

#include <qtextcodec.h>
#define _T(str) QTextCodec::codecForLocale()->toUnicode(str)

LUSSSPicture::LUSSSPicture()
: m_pWidget(0), ref(0)
{
}

LUSSSPicture::~LUSSSPicture(  )
{
}

QString LUSSSPicture::Name()
{
	return _T( "饤ɥ硼" );
}

QString LUSSSPicture::Version()
{
	return _T( "1.0.0" );
}

QString LUSSSPicture::Comment()
{
	return _T( "줿ǥ쥯ȥǤޤ" );
}

void LUSSSPicture::Setting()
{
	LUSSSPictureSetting dlg( NULL, _T(""), TRUE, 0 );
	dlg.exec();
}

QWidget* LUSSSPicture::Init( int nMode )
{
	switch( nMode )
	{
	case LUS_NORMAL:
		{
			m_pWidget = new LUSSSPictureWidget( NULL );
		}
		break;
	case LUS_PREVIEW:
		{
			m_pWidget = new LUSSSPictureWidget( NULL );
		}
		break;
	default:
		{
			m_pWidget = NULL;
		}
		break;
	}
	
	return (QWidget*)m_pWidget;
}

void LUSSSPicture::Start()
{
	if ( m_pWidget )
	{
		m_pWidget->Start();
	}
}

void LUSSSPicture::Stop()
{
	if ( m_pWidget )
	{
		m_pWidget->Stop();
		delete m_pWidget;
	}
}

QRESULT LUSSSPicture::queryInterface(const QUuid& uuid,
	QUnknownInterface** iface)
{
	*iface = 0;
	if(uuid == IID_QUnknown)
	{
		*iface = this;
	}
	else if ( uuid == IID_LUSScreenSaver )
	{
		*iface = this;
	}

	if(*iface)
	{
		(*iface)->addRef();
	}

	return QS_OK;
}

Q_EXPORT_INTERFACE()
{
	Q_CREATE_INSTANCE( LUSSSPicture )
}
